
/* Chrysalide - Outil d'analyse de fichiers binaires
 * loading.h - prototypes pour les chargements parallèles des symboles de format ELF
 *
 * Copyright (C) 2016-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _FORMAT_ELF_LOADING_H
#define _FORMAT_ELF_LOADING_H


#include "elf.h"
#include "../../gtkext/gtkstatusstack.h"




//#include "../routine.h"
//#include "../../arch/processor.h"
//#include "../../format/executable.h"
//#include "../../gtkext/gtkstatusstack.h"



#define G_TYPE_ELF_LOADING              g_elf_loading_get_type()
#define G_ELF_LOADING(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), g_elf_loading_get_type(), GElfLoading))
#define G_IS_ELF_LOADING(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_elf_loading_get_type()))
#define G_ELF_LOADING_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ELF_LOADING, GElfLoadingClass))
#define G_IS_ELF_LOADING_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ELF_LOADING))
#define G_ELF_LOADING_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ELF_LOADING, GElfLoadingClass))


/* Fraction de loading à limiter (instance) */
typedef struct _GElfLoading GElfLoading;

/* Fraction de loading à limiter (classe) */
typedef struct _GElfLoadingClass GElfLoadingClass;


/* Assure un chargement pour ELF en différé. */
typedef bool (* elf_loading_cb) (GElfLoading *, GElfFormat *, phys_t *);


/* Indique le type défini pour les tâches de chargements pour format ELF. */
GType g_elf_loading_get_type(void);

/* Crée une tâche de chargement pour ELF différée. */
GElfLoading *g_elf_loading_new(GElfFormat *, const elf_shdr *, bool, phys_t, phys_t, phys_t, activity_id_t, elf_loading_cb);

/* Fournit les infos utiles au chargement de symbols internes. */
void g_elf_loading_get_internal_info(GElfLoading *, const elf_shdr **, bool *, const elf_shdr **, bool *, phys_t *);



#endif  /* _FORMAT_ELF_LOADING_H */
